local _, var, var1, var2

--[[--------------------------------------------------------------------------------
 interface
-----------------------------------------------------------------------------------]]

_, var = UnitClass("player")
if var == "DRUID" then
    PlayerMana = function () if DruidManaDB then return DruidManaDB.Current else return 0 end end
    PlayerManaMax = function () if DruidManaDB then return DruidManaDB.Maximum else return 0 end end
else
    if var == "WARRIOR" or var == "ROGUE" then 
        PlayerMana = function () return 0 end
        PlayerManaMax = function () return 0 end
    else
        PlayerMana = function () return UnitMana("player") end
        PlayerManaMax = function () return UnitManaMax("player") end
    end
    return
end

--[[--------------------------------------------------------------------------------
  Initialize
-----------------------------------------------------------------------------------]]

CreateFrame("GameTooltip", "DruidMana", UIParent, "GameTooltipTemplate")
DruidMana:RegisterEvent("PLAYER_LOGIN")
DruidMana:SetScript("OnEvent", function () this[event](this) end)
DruidMana:SetScript("OnUpdate", function ()
        if this.fiveStop then
            this.fiveStop = this.fiveStop - arg1
            if this.fiveStop < 0 then this.fiveStop = nil end
        end
    end
)
DruidMana.MANA_COST = string.gsub(MANA_COST, "%%d", "(%%d+)")

--[[--------------------------------------------------------------------------------
  Events
-----------------------------------------------------------------------------------]]

function DruidMana:PLAYER_LOGIN ()
    if not DruidManaDB then DruidManaDB = {} end
    self.db = DruidManaDB
    if not self.db.Current then self.db.Current = 0 end
    if not self.db.Maximum then self.db.Maximum = 0 end
    self:HasMana()
    self:PlayerIntellect()
    self:LEARNED_SPELL_IN_TAB()
    self:RegisterEvent("PLAYER_ENTERING_WORLD")
    self:RegisterEvent("PLAYER_LEAVING_WORLD")
end

function DruidMana:PLAYER_ENTERING_WORLD()
    self:RegisterEvent("LEARNED_SPELL_IN_TAB")
    self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
    self:RegisterEvent("UNIT_DISPLAYPOWER")
    self:RegisterEvent("UNIT_MAXMANA")
    self:RegisterEvent("UNIT_MANA")
end

function DruidMana:PLAYER_LEAVING_WORLD()
    self:UnregisterEvent("LEARNED_SPELL_IN_TAB")
    self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
    self:UnregisterEvent("UNIT_DISPLAYPOWER")
    self:UnregisterEvent("UNIT_MAXMANA")
    self:UnregisterEvent("UNIT_MANA")
end

function DruidMana:LEARNED_SPELL_IN_TAB ()
    for t = 1, GetNumSpellTabs() do
        _, var, var1, var2 = GetSpellTabInfo(t)
        if string.find(var, "Ability_Racial_BearForm") then 
            for s = 1 + var1, var1 + var2 do
                var = GetSpellTexture(s, BOOKTYPE_SPELL)
                if string.find(var, "Ability_Racial_BearForm") then 
                    self.BearSpellID = s
                    self.BearSpellNM = GetSpellName(s, BOOKTYPE_SPELL)
                elseif string.find(var, "Ability_Druid_CatForm") then 
                    self.CatSpellID= s
                    self.CatSpellNM = GetSpellName(s, BOOKTYPE_SPELL)
                end
            end
            break
        end
    end
end

function DruidMana:UNIT_MAXMANA()
    var = self:PlayerIntellect()
    if not self:HasMana() then
        self.db.Maximum = self.db.Maximum + (self.statIntellect - var) * 15
    end
end

function DruidMana:UNIT_SPELLCAST_SUCCEEDED ()
    if arg1 ~= "player" then return end
    self:HasMana()
    if arg2 == self.BearSpellNM then 
        self.shiftCasted = self.BearSpellID
        self.fiveStop = 5
    elseif arg2 == self.CatSpellNM then 
        self.shiftCasted = self.CatSpellID
        self.fiveStop = 5 
    end
end

function DruidMana:UNIT_MANA()
    if arg1 ~= "player" then return end
    if self:HasMana() then return end
    if self.shiftCasted then
        if not self:IsOwned(UIParent) then self:SetOwner(UIParent, "ANCHOR_NONE") end
        self:SetSpell(self.shiftCasted, BOOKTYPE_SPELL)
        _, _, var = string.find(DruidManaTextLeft2:GetText(), self.MANA_COST)
        self.db.Current = self.db.Current - tonumber(var)
        self.shiftCasted = nil
        return
    end
    if self.fiveStop then 
        _, var = GetManaRegen()
        self.db.Current = self.db.Current + floor( var * 2.0 )
    else
        var, _ = GetManaRegen()
        self.db.Current = self.db.Current + floor( var * 2.0 )
    end
end

function DruidMana:UNIT_DISPLAYPOWER()
    if arg1 ~= "player" then return end
    if not self:HasMana() then self.shiftCasted = nil end
end

--[[--------------------------------------------------------------------------------
 Helpers
-----------------------------------------------------------------------------------]]

function DruidMana:HasMana()
    if UnitPowerType("player") == 0 then 
        self.db.Current = UnitMana("player")
        self.db.Maximum = UnitManaMax("player")
        return true
    else
        return false
    end
end

function DruidMana:PlayerIntellect()
    var = self.statIntellect
    _, self.statIntellect = UnitStat("player", 4)
    return var
end
